local name, tab = ...
tab['frame'] = CreateFrame("Frame",name,UIParent)
local f = tab['frame']

local bars = {}
local barNum = 5
local playBar = function() end -- dummy

local function playBar(bar, txt, event)
	bar['textorg'] = txt
	if(event == "UI_INFO_MESSAGE") then
		bar:SetStatusBarColor(1,1,0,1)
	elseif(event == "UI_ERROR_MESSAGE") then
		txt = tab['db']['data'][txt]['count'] > 1 and format("%s (%i)",txt,tab['db']['data'][txt]['count']) or txt
		bar:SetStatusBarColor(1,0,0,1)
	else
		bar:SetStatusBarColor(1,.5,.1,1)
	end
	bar['text']:SetText(txt)
	bar['ani']:Play()
end

local function addAnimation(n)
	local ani = n:CreateAnimationGroup()
	ani:SetLooping("NONE")
	local alpha = ani:CreateAnimation("Alpha")
	alpha:SetOrder(1)
	alpha:SetDuration(0)
	alpha:SetChange(1)
	alpha:SetScript("OnPlay",function(self) self:GetParent():GetParent()['lastplayed'] = time() end)
	local alpha2 = ani:CreateAnimation("Alpha")
	alpha2:SetOrder(2)
	alpha2:SetDuration(7)
--	alpha2:SetMaxFramerate(25)
	alpha2:SetChange(-1)
	alpha2:SetScript("OnFinished",function(self) if(tab['db']['data'][self:GetParent():GetParent()['textorg']] and tab['db']['data'][self:GetParent():GetParent()['textorg']]['count']) then tab['db']['data'][self:GetParent():GetParent()['textorg']]['count'] = 0 end;self:GetParent():GetParent()['text']:SetText("") ; playBar(self:GetParent():GetParent())end)
	return ani
end

local function clearAnimation(n)
	n:Hide()
	n['ani']:Stop()
	n['ani'] = addAnimation(n)
	n:Show()
end

local function createBar(txt)
	local n = CreateFrame("StatusBar", "$PARENTBar",f)
	tab['framelist'][#tab['framelist'] + 1] = n
	n:SetWidth(480)
	n:SetHeight(20)
	n:SetPoint("TOPLEFT", tab['lastframe'], "BOTTOMLEFT", 0, -2)
	n:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
	n:SetStatusBarColor(1,.5,.1,1)
	n:GetStatusBarTexture():SetHorizTile(false)
	n:GetStatusBarTexture():SetVertTile(false)
	n:SetAlpha(0)
	
	n['text'] = n:CreateFontString("$PARENTText","OVERLAY","GameFontHighlight")
	n['text']:SetText(txt)
	n['text']:SetWidth(480)
	n['text']:SetHeight(20)
	n['text']:SetAllPoints(n)

	n['ani'] = addAnimation(n)
	
	tab['lastframe'] = n
end

local function getBar(txt)
	for k = 1,barNum do
		if(tab['framelist'][k]['textorg'] == txt) then
			clearAnimation(tab['framelist'][k])
			return tab['framelist'][k]
		end
	end
	for k = 1,barNum do
		if(not tab['framelist'][k]['ani']:IsPlaying()) then
			return tab['framelist'][k]
		end
	end
	local last = 0
	local ret = tab['framelist'][1]
	for k = 1,barNum do
		if(last > tab['framelist'][k]['lastplayed'] or last == 0) then
			ret = tab['framelist'][k]
		end
	end
	clearAnimation(ret)
	return ret
end



local function init()
	zz_ErrorWatch = zz_ErrorWatch or {}
	tab['db'] = zz_ErrorWatch
	tab['db']['msg'] = tab['db']['msg'] or {}
	tab['db']['data'] = tab['db']['data'] or {}
	tab['db']['window'] = tab['db']['window'] or {
		['dragAble']=true,
	}
	f['tab'] = tab['db']['window']

end

local function showText()
	tab['framelist'] = {}
	tab['lastframe'] = CreateFrame("Frame", nil, f)
	tab['lastframe']:SetWidth(240)
	tab['lastframe']:SetHeight(20)
	tab['lastframe']:SetPoint("BOTTOMLEFT", f, "TOPLEFT", 0, 2)
	for v = 1,barNum do
		createBar("")
	end
end

local function setupUI()
	f:SetWidth(480)
	f:SetHeight(20)
	f:SetFrameStrata("FULLSCREEN_DIALOG")
--	f:SetPoint("CENTER", UIParent, "CENTER", 0,0)
	tab['lastframe'] = CreateFrame("Frame", nil, f)
	tab['lastframe']:SetWidth(240)
	tab['lastframe']:SetHeight(20)
	tab['lastframe']:SetPoint("BOTTOMLEFT", f, "TOPLEFT", 0, 2)
	tab['addDrag'](f,nil,tab['db']['window'])
	tab['loadFrame'](f)
	showText()
end

local function OnEvent(self, event, arg)
	if(event == "PLAYER_LOGIN" or (event == "ADDON_LOADED" and arg == name)) then
		init()
		setupUI()
		f:RegisterEvent("UI_ERROR_MESSAGE")
		f:RegisterEvent("UI_INFO_MESSAGE")
		f:UnregisterEvent("PLAYER_LOGIN")
		f:UnregisterEvent("ADDON_LOADED")
		UIErrorsFrame:UnregisterEvent("UI_ERROR_MESSAGE")
		UIErrorsFrame:UnregisterEvent("UI_INFO_MESSAGE")
		return
	elseif(event == "UI_ERROR_MESSAGE" or event == "UI_INFO_MESSAGE") then
		if(event == "UI_ERROR_MESSAGE") then
			local s = false
			for k,v in ipairs(tab['db']['msg']) do
				if v == arg then 
					s = true
					break
				end
			end
			if not s then
				tab['db']['msg'][#tab['db']['msg'] + 1] = arg
				tab['db']['data'][arg] = tab['db']['data'][arg] or {
					['count'] = 1,
					['last seen'] = time(),
				}
			else
				tab['db']['data'][arg] = tab['db']['data'][arg] or {
					['count'] = 1,
					['last seen'] = time(),
				}
				tab['db']['data'][arg]['count'] = tab['db']['data'][arg]['count'] + 1 or 1
				tab['db']['data'][arg]['last seen'] = time()
			end
		end
		playBar(getBar(arg), arg, event)
	end
end
f:RegisterEvent("ADDON_LOADED")
f:RegisterEvent("PLAYER_LOGIN")


f:SetScript("OnEvent", OnEvent)
 