local name, lib = ...

lib['round'] = function(num, idp)
  return math.floor(num * (10^(idp or 0)) + 0.5) / (10^(idp or 0))
end

lib['switch'] = function(self,value)
	if(value) then
		self:Show()
	else
		self:Hide()
	end
end

local function saveFrame(self)
	local x, y = self:GetCenter() 
	local s = self:GetEffectiveScale()
	local uis = UIParent:GetScale()
	x = x*s - GetScreenWidth()*uis/2
	y = y*s - GetScreenHeight()*uis/2
	self['tab']['xpos'] = lib.round(x/uis,0)
	self['tab']['ypos'] = lib.round(y/uis,0)
--	print("Save",self:GetName(),self.tab['xpos'],self.tab['ypos'])
end
	
lib['loadFrame'] = function(self)
	if not self then return end
	if( InCombatLockdown() ) then
		if(lib['addSchedule']) then
			lib['addSchedule'](self, "loadframe")
		end
		return
	end
--	print("Load",self:GetName(),self.tab['xpos'],self.tab['ypos'])
	local s = self:GetEffectiveScale()
	local uis = UIParent:GetScale()
	local x = self['tab']['xpos'] or 0
	local y = self['tab']['ypos'] or 0
	self:ClearAllPoints()
	self:SetPoint("CENTER", UIParent, "CENTER", x*uis/s, y*uis/s)
end


lib['center'] = function(self)
	self:ClearAllPoints()
	self:SetPoint("Center", UIParent,"Center",0,0)
	saveFrame(self)
end

lib['toggle'] = function(self)
	if(self:IsVisible()) then
		self:Hide()
	else
		self:Show()
	end
end

local function startMove(self)
	if InCombatLockdown() then return end
	if(self['moveparent']) then
		self:GetParent():StartMoving()
	else
		self:StartMoving()
	end
end

local function stopMove(self)
	if(self['moveparent']) then
		self:GetParent():StopMovingOrSizing()
		saveFrame(self:GetParent())
	else
		self:StopMovingOrSizing()
		saveFrame(self)
	end
end

local function dragView(self)
  if(IsAltKeyDown() and self:GetParent()['tab'] and self:GetParent()['tab']['dragAble']) then
    self['tex']:SetTexture(0, .5, 0, .5)
		self:Show()
  else
		if(self:IsVisible()) then
			self['tex']:SetTexture(0, 1, 0 , 0)
			stopMove(self)
			self:Hide()
		end
  end
end

lib['addDrag'] = function(frame,typ,tab)
	tab = tab or {}
	frame['dragframe'] = frame['dragframe'] or CreateFrame("Frame","$PARENTdrag",frame)
	frame['dragframe']:SetFrameStrata("LOW")
	frame:SetMovable(true)
  frame['dragframe']:SetMovable(true)
  frame['dragframe']:EnableMouse(true)
	frame['dragframe']['moveparent'] = true
	frame['dragframe']:SetScript("OnMouseDown", startMove)
	frame['dragframe']:SetScript("OnMouseUp", stopMove)
	if(typ == "BOX") then
		frame['dragframe']:SetWidth(tab['width'] or 32)
		frame['dragframe']:SetHeight(tab['height'] or 32)
		frame['dragframe']:SetPoint(tab['anchor'] or "BOTTOMLEFT", frame, tab['parentanchor'] or "TOPLEFT", tab['xOffset'] or 0, tab['yOffset'] or 0)
	else
		local offset = tab['offset'] or 16
		frame['dragframe']:SetWidth(frame:GetWidth() + offset)
		frame['dragframe']:SetHeight(frame:GetHeight() + offset)
		frame['dragframe']:SetPoint("TOPLEFT", frame, "TOPLEFT", -offset/2, offset/2)
	end
	frame['dragframe']['tex'] = frame['dragframe']['tex'] or frame['dragframe']:CreateTexture()
	frame['dragframe']['tex']:SetAllPoints(frame['dragframe'])
	frame['dragframe']['tex']:SetTexture(0,0,0,0)
	frame['dragframe']:RegisterEvent("MODIFIER_STATE_CHANGED")
	frame['dragframe']:SetScript("OnEvent",dragView)
	frame.dragframe:Hide()
end